package ext.cust.toc;

import ext.cust.Const;
import ext.cust.dao.CustomizeOMPTOCDAO;
import ext.cust.dgis.process.FlexibleProcess;
import ext.cust.generic.util.DateUtil;
import ext.cust.generic.util.GenericUtil;
import ext.cust.generic.util.IBAUtil;
import ext.cust.generic.util.PartUtil;
import ext.cust.generic.util.XMLUtil;
import ext.cust.generic.util.ZipUtil;
import ext.cust.service.dataTable.PublishDocViewDataTable;
import ext.cust.sis.PubProcess;
import ext.cust.toc.pojo.Part;
import ext.cust.toc.pojo.TOCEntryExport;
import ext.cust.util.WorkflowUtil;
import ext.cust.workflow.WorkflowService;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import org.dom4j.Document;
import org.dom4j.Element;
import org.dom4j.tree.DefaultAttribute;
import wt.content.ApplicationData;
import wt.content.ContentHelper;
import wt.content.ContentHolder;
import wt.content.ContentItem;
import wt.content.ContentRoleType;
import wt.content.ContentServerHelper;
import wt.content.StandardContentService;
import wt.doc.WTDocument;
import wt.epm.EPMDocument;
import wt.fc.PersistenceHelper;
import wt.fc.WTObject;
import wt.part.WTPart;
import wt.pom.Transaction;
import wt.session.SessionServerHelper;
import wt.util.WTException;
import wt.vc.config.LatestConfigSpec;

/* loaded from: PushProcess.class */
public class PushProcess {
    public String pushXMLdata(WTObject pbo) {
        ApplicationData app;
        ApplicationData app2;
        ApplicationData app3;
        Transaction trans = new Transaction();
        WTDocument publishDoc = (WTDocument) pbo;
        IBAUtil iba = new IBAUtil(publishDoc);
        Map map = iba.getIBAValues();
        String PubPartNo = (String) map.get("PubPartNo");
        String PartNo = (String) map.get("PartNo");
        String PushDataType = (String) map.get("PushDataType");
        String lang = (String) map.get("SourceLanguage");
        String filename = (String) map.get("ExtFileName");
        String importType = (String) map.get("ImportType");
        String cmmtoc = new StringBuilder().append(map.get(Const.IBA_SCMORHOMMTOC)).toString();
        System.out.println("-------------:" + map.toString());
        try {
            try {
                if ("Scene".equals(importType)) {
                    System.out.println("***********************推送场景手册文档生成开始***********************");
                    FlexibleProcess fp = new FlexibleProcess();
                    WTPart part = WorkflowService.getPartByNumber(PubPartNo);
                    String oid = new StringBuilder(String.valueOf(GenericUtil.REF_FACTORY.getReferenceString(part))).toString();
                    if (!"".equals(filename) && (app3 = GenericUtil.getAttachmentFromDocument(publishDoc, filename)) != null) {
                        String path = app3.getUploadedFromPath();
                        System.out.println("*********************文件路径：" + path);
                        String[] str = fp.scenarioManual(oid, cmmtoc, path, PartNo);
                        System.out.println("str=" + str);
                        if ("0".equals(str[0].toString())) {
                            System.out.println("场景手册抽取失败");
                            if (trans == null) {
                                return null;
                            }
                            trans.rollback();
                            return null;
                        }
                        String generateFileName = str[1];
                        writeFiletoWTDocByFlexible(new File(generateFileName), publishDoc, "SCM");
                        System.out.println("场景手册抽取成功");
                        if (trans != null) {
                            trans.rollback();
                        }
                        return generateFileName;
                    }
                    System.out.println("***********************推送场景手册文档生成结束***********************");
                } else if ("VIM".equals(importType)) {
                    System.out.println("***********************推送视频手册文档生成开始***********************");
                    FlexibleProcess fp2 = new FlexibleProcess();
                    WTPart part2 = WorkflowService.getPartByNumber(PubPartNo);
                    String oid2 = new StringBuilder(String.valueOf(GenericUtil.REF_FACTORY.getReferenceString(part2))).toString();
                    if (!"".equals(filename) && (app2 = GenericUtil.getAttachmentFromDocument(publishDoc, filename)) != null) {
                        String path2 = app2.getUploadedFromPath();
                        System.out.println("*********************文件路径：" + path2);
                        String[] str2 = fp2.VIMManual(oid2, cmmtoc, path2, PartNo);
                        System.out.println("str=" + str2);
                        if ("0".equals(str2[0].toString())) {
                            System.out.println("视频手册抽取失败");
                            if (trans == null) {
                                return null;
                            }
                            trans.rollback();
                            return null;
                        }
                        String generateFileName2 = str2[1];
                        writeFiletoWTDocByFlexible(new File(generateFileName2), publishDoc, "VIM");
                        System.out.println("视频手册抽取成功");
                        if (trans != null) {
                            trans.rollback();
                        }
                        return generateFileName2;
                    }
                    System.out.println("***********************推送视频手册文档生成结束***********************");
                } else if ("hotSpot".equals(importType)) {
                    System.out.println("***********************推送热点手册文档生成开始***********************");
                    FlexibleProcess fp3 = new FlexibleProcess();
                    WTPart part3 = WorkflowService.getPartByNumber(PubPartNo);
                    String oid3 = new StringBuilder(String.valueOf(GenericUtil.REF_FACTORY.getReferenceString(part3))).toString();
                    if (!"".equals(filename) && (app = GenericUtil.getAttachmentFromDocument(publishDoc, filename)) != null) {
                        String path3 = app.getUploadedFromPath();
                        System.out.println("*********************" + path3);
                        String[] str3 = fp3.hotSpotManual(oid3, cmmtoc, path3, PartNo);
                        System.out.println("str=" + str3);
                        if ("0".equals(str3[0].toString())) {
                            System.out.println("热点手册抽取失败");
                            if (trans == null) {
                                return null;
                            }
                            trans.rollback();
                            return null;
                        }
                        String generateFileName3 = str3[1];
                        writeFiletoWTDocByFlexible(new File(generateFileName3), publishDoc, "HOM");
                        System.out.println("热点手册抽取成功");
                        if (trans != null) {
                            trans.rollback();
                        }
                        return generateFileName3;
                    }
                    System.out.println("***********************推送热点手册文档生成结束***********************");
                } else {
                    WTPart pub = PartUtil.getPart(PubPartNo, "");
                    System.out.println(pub.getNumber());
                    String zipPath = exportPTOCXML(pub, lang, PartNo, PushDataType, importType, filename, publishDoc);
                    if (zipPath != null) {
                        WTDocument publishDoc2 = GenericUtil.checkin(GenericUtil.checkout(publishDoc));
                        trans.start();
                        writeFiletoWTDoc(new File(zipPath), publishDoc2);
                        trans.commit();
                        Transaction trans2 = null;
                        if (0 != 0) {
                            trans2.rollback();
                        }
                        return zipPath;
                    }
                }
                if (trans == null) {
                    return null;
                }
                trans.rollback();
                return null;
            } catch (Exception e) {
                e.printStackTrace();
                if (trans == null) {
                    return null;
                }
                trans.rollback();
                return null;
            }
        } catch (Throwable th) {
            if (trans != null) {
                trans.rollback();
            }
            throw th;
        }
    }

    public static Set<String> FindGIONode(Document doc) throws WTException {
        Element rootEle = doc.getRootElement();
        Set<String> gios = new HashSet<>();
        List<Element> list = rootEle.selectNodes("//graphic");
        for (Element element : list) {
            gios.add(element.attributeValue("object-id"));
        }
        return gios;
    }

    public String generateXML(WTPart wtpart, String language, String pubParm) {
        boolean enforce = SessionServerHelper.manager.setAccessEnforced(false);
        try {
            try {
                System.out.println("-------开始推送XML");
                Set<String> graphics = new HashSet<>();
                List languageList = new ArrayList();
                languageList.add(language);
                System.out.println("-----推送XML toPart开始");
                Part part = TOCUtil.toPart(wtpart, "", true, true, languageList, false, true, false, true, graphics, false, (List) null, false, false);
                System.out.println("-----推送XML toPart结束");
                System.out.println("-----推送XML 开始写入章节号信息");
                List<WTPart> rootWTPart = new ArrayList<>();
                Part part2 = TOCUtil.getParentPart(part, wtpart, rootWTPart);
                TOCUtil.getChapterNum(rootWTPart.get(0), part2, Const.CS_LATEST, wtpart.getNumber());
                System.out.println("-----推送XML 结束写入章节号信息");
                boolean loadMicroSection = false;
                if (part2.getSoftType().equals("wt.part.WTPart|com.patac.TOCItem|com.patac.Publication|com.patac.PTOCSM")) {
                    loadMicroSection = true;
                }
                String xmlFileContent = TOCUtil.toXmlForPart(part2, language, (String) null, loadMicroSection);
                System.out.println("----推送XML 开始处理CELL LINK");
                Map allIE = new LinkedHashMap();
                TOCUtil.getALLIE(languageList, rootWTPart.get(0), new LatestConfigSpec(), allIE);
                String xmlFileContent2 = dealCellLink(language, xmlFileContent, allIE, pubParm);
                System.out.println("----推送XML 处理CELL LINK结束");
                SessionServerHelper.manager.setAccessEnforced(enforce);
                return xmlFileContent2;
            } catch (Exception e) {
                e.printStackTrace();
                SessionServerHelper.manager.setAccessEnforced(enforce);
                return null;
            }
        } catch (Throwable th) {
            SessionServerHelper.manager.setAccessEnforced(enforce);
            throw th;
        }
    }

    public String exportPTOCXML(WTPart wtpart, String language, String partno, String pubParm, String importType, String fileExternal, WTDocument doc) throws Exception {
        boolean enforce = SessionServerHelper.manager.setAccessEnforced(false);
        try {
            try {
                System.out.println("-------开始推送XML");
                Set<String> graphics = new HashSet<>();
                Set<String> videos = new HashSet<>();
                List languageList = new ArrayList();
                languageList.add(language);
                System.out.println("-----推送XML toPart开始");
                Part part = TOCUtil.toPart(wtpart, "", true, true, languageList, false, true, false, true, graphics, false, (List) null, false, false, true, videos);
                System.out.println("-----推送XML toPart结束");
                System.out.println("-----推送XML 开始写入章节号信息");
                List<WTPart> rootWTPart = new ArrayList<>();
                Part part2 = TOCUtil.getParentPart(part, wtpart, rootWTPart);
                TOCUtil.getChapterNum(rootWTPart.get(0), part2, Const.CS_LATEST, wtpart.getNumber());
                System.out.println("-----推送XML 结束写入章节号信息");
                boolean loadMicroSection = part2.getSoftType().equals("wt.part.WTPart|com.patac.TOCItem|com.patac.Publication|com.patac.PTOCSM");
                String xmlFileContent = TOCUtil.toXmlForPart(part2, language, (String) null, loadMicroSection);
                System.out.println("----推送XML 开始处理CELL LINK");
                Map allIE = new LinkedHashMap();
                TOCUtil.getALLIE(languageList, rootWTPart.get(0), new LatestConfigSpec(), allIE);
                String xmlFileContent2 = dealCellLink(language, xmlFileContent, allIE, pubParm);
                System.out.println("----推送XML 结束处理CELL LINK");
                String xmlName = part2.getNumber();
                String filePath = PTOCUtil.createXmlFile(xmlFileContent2, "ExportPTOCXml", xmlName, ".xml");
                File file = new File(filePath);
                String basePath = file.getParentFile().getAbsolutePath();
                Document document = XMLUtil.parseXMLContent(xmlFileContent2);
                if (document == null) {
                    System.out.println("XML 文件格式或编号不正确");
                    SessionServerHelper.manager.setAccessEnforced(enforce);
                    return null;
                }
                Element root = document.getRootElement();
                PubProcess sisServ = new PubProcess();
                if (!"".equals(fileExternal)) {
                    String ptocpno = wtpart.getNumber();
                    ApplicationData app = GenericUtil.getAttachmentFromDocument(doc, fileExternal);
                    if (app != null) {
                        InputStream is = ContentServerHelper.service.findContentStream(app);
                        sisServ.getMPtocData(ptocpno, language);
                        if ("RPO".equals(importType)) {
                            List<String> rpoList = sisServ.getRPOListFromFile(is);
                            if (rpoList != null && rpoList.size() >= 0) {
                                sisServ.getSISDatafilterByRpo(rpoList, language, false);
                            }
                        } else {
                            sisServ.getSISDataByExternal(is, language);
                        }
                        List<Element> sisLinkList = root.selectNodes(".//servinfosub");
                        for (Element ele : sisLinkList) {
                            String objectId = ele.attributeValue("object-id");
                            Element parent = ele.getParent();
                            String oieId = parent.attributeValue("object-id");
                            boolean lbExists = false;
                            int i = 0;
                            while (true) {
                                if (i >= sisServ.sisData.size()) {
                                    break;
                                }
                                String sisNO = ((TOCEntryExport) sisServ.sisData.get(i)).getSioNo();
                                String oieNo = ((TOCEntryExport) sisServ.sisData.get(i)).getIeNo();
                                String sioType = ((TOCEntryExport) sisServ.sisData.get(i)).getSioType();
                                if (sioType != null && sioType.equals("SIS") && sisNO != null && sisNO.equals(objectId) && oieNo.equalsIgnoreCase(String.valueOf(oieId) + "_" + language)) {
                                    lbExists = true;
                                    sisServ.sisData.remove(i);
                                    break;
                                }
                                i++;
                            }
                            if (!lbExists) {
                                parent.remove(ele);
                            }
                        }
                    }
                }
                PrePublishProcess.removeNoServinfosub(root, "section");
                PrePublishProcess.removeNoServinfosub(root, "subsection");
                PrePublishProcess.removeNoServinfosub(root, "servinfo");
                PrePublishProcess.resort(document);
                System.out.println("----推送XML 开始导出图片");
                String graphicsPath = String.valueOf(basePath) + File.separator + "graphics";
                File gFile = new File(graphicsPath);
                gFile.mkdirs();
                for (String graphic : graphics) {
                    EPMDocument graphicDoc = GenericUtil.getEPMDocumentByCADName(graphic);
                    if (graphicDoc != null) {
                        GenericUtil.saveToDir(graphicDoc, graphicsPath);
                    }
                }
                System.out.println("----推送XML 结束导出图片");
                System.out.println("----导出PTOC XML 开始导出视频");
                String videosPath = String.valueOf(basePath) + File.separator + "graphics";
                File videoFile = new File(videosPath);
                videoFile.mkdirs();
                for (String video : videos) {
                    EPMDocument videoDoc = GenericUtil.getEPMDocumentByCADName(video);
                    System.out.println("导出视频编号：" + video);
                    if (videoDoc != null) {
                        GenericUtil.saveToDir(videoDoc, videosPath);
                    }
                }
                System.out.println("----导出PTOC XML 结束导出视频");
                String zipPath = file.getParentFile().getParentFile().getAbsolutePath();
                if (!file.exists()) {
                    file.mkdir();
                }
                String zipPath2 = zipPath.endsWith(File.separator) ? String.valueOf(zipPath) + partno + "_" + DateUtil.getDateTimeString() + ".zip" : String.valueOf(zipPath) + File.separator + partno + "_" + DateUtil.getDateTimeString() + ".zip";
                ZipUtil.zipByCmd(basePath, zipPath2);
                System.out.println("==============================推送XML end:" + zipPath2);
                System.out.println(zipPath2);
                String title = "推送数据成功：" + wtpart.getNumber() + " - " + wtpart.getName();
                String path = GenericUtil.getFileUrl(zipPath2);
                String content = "请点击<a href='" + path + "'>下载</a>";
                WorkflowUtil.startSendEMAIL(wtpart, title, content);
                System.out.println("==============已启动发送流程");
                String str = zipPath2;
                SessionServerHelper.manager.setAccessEnforced(enforce);
                return str;
            } catch (Exception e) {
                e.printStackTrace();
                String title2 = "导出PTOC(XML)失败：" + wtpart.getNumber() + " - " + wtpart.getName();
                String content2 = "对不起，导出失败:" + e.getMessage();
                WorkflowUtil.startSendEMAIL(wtpart, title2, content2);
                SessionServerHelper.manager.setAccessEnforced(enforce);
                return null;
            }
        } catch (Throwable th) {
            SessionServerHelper.manager.setAccessEnforced(enforce);
            throw th;
        }
    }

    private String dealCellLink(String language, String xmlFileContent, Map allIE, String pubParm) {
        String xmlFileContent2 = xmlFileContent.replace("x-wc://file=", "");
        if (language.equals("zh_CN")) {
            xmlFileContent2 = xmlFileContent2.replace("</cell-link>、<cell-link", "</cell-link><cell-link").replace("</cell-link>和<cell-link", "</cell-link><cell-link").replace("</cell-link>或<cell-link", "</cell-link><cell-link");
        }
        Document document = XMLUtil.parseXMLContent(xmlFileContent2);
        Element root = document.getRootElement();
        List<Element> cellLinkList = root.selectNodes(".//cell-link");
        List<String> beforeCellID = new ArrayList<>();
        for (Element child : cellLinkList) {
            beforeCellID = PTOCUtil.cellLink(allIE, child, beforeCellID);
        }
        String xmlFileContent3 = XMLUtil.getDocumentXML(PrePublishProcess.dealPubParm(document, pubParm));
        if (language.equals("zh_CN")) {
            xmlFileContent3 = xmlFileContent3.replace("</cell-link><cell-link", "</cell-link>、<cell-link").replace("、、", "").replace("、。", "。").replace("，，", "").replace("，。", "。");
        }
        return xmlFileContent3;
    }

    private Document dealCellLink(Document doc) {
        List<Element> refs = doc.selectNodes("//warning-ref|//caution-ref");
        for (int i = 0; i < refs.size(); i++) {
            List<Element> celllinks = refs.get(i).selectNodes("ptxt/cell-link");
            if (celllinks.size() != 0) {
                String cellid = ((DefaultAttribute) celllinks.get(0).attributes().get(1)).getValue();
                List<Element> sios = doc.selectNodes("//servinfo[@object-id='" + cellid + "']/caution-sio|//servinfo[@object-id='" + cellid + "']/warning-sio");
                if (sios.size() != 0) {
                    List elepar = refs.get(i).getParent().content();
                    elepar.set(elepar.indexOf(refs.get(i)), sios.get(0));
                }
            }
        }
        String docContent = doc.asXML();
        List<Element> links = doc.selectNodes("//cell-link");
        for (int i2 = 0; i2 < links.size(); i2++) {
            docContent = docContent.replace(links.get(i2).asXML(), "请参见维修手册 " + links.get(i2).getText());
        }
        Document doc2 = XMLUtil.parseXMLContent(docContent);
        List<Element> section = doc2.selectNodes("//section[@secnum='0']");
        List secpar = section.get(0).getParent().content();
        secpar.remove(section.get(0));
        return doc2;
    }

    public static boolean writeFiletoWTDoc(File file, WTDocument doc) {
        try {
            ContentHolder contentholder = ContentHelper.service.getContents(doc);
            List<Object> contentListForTarget = ContentHelper.getContentListAll(contentholder);
            int i = 0;
            while (true) {
                if (i >= contentListForTarget.size()) {
                    break;
                }
                ContentItem contentItem = (ContentItem) contentListForTarget.get(i);
                if (!"PRIMARY".equals(contentItem.getRole().toString())) {
                    i++;
                } else {
                    ContentServerHelper.service.deleteContent(contentholder, contentItem);
                    break;
                }
            }
            ApplicationData appData = ApplicationData.newApplicationData(doc);
            appData.setRole(ContentRoleType.PRIMARY);
            appData.setFileName(String.valueOf(doc.getName()) + "--" + file.getName());
            String fileName = String.valueOf(doc.getName()) + "--" + file.getName();
            StandardContentService.setFormat(fileName, appData);
            InputStream is = new FileInputStream(file);
            ContentServerHelper.service.updateContent(doc, appData, is);
            WTDocument doc2 = PersistenceHelper.manager.refresh(doc);
            String version = doc2.getVersionIdentifier().getValue();
            String iter = doc2.getIterationIdentifier().getValue();
            String versionInfo = String.valueOf(version.toUpperCase()) + iter.toUpperCase();
            System.out.println("**********************writeFiletoWTDoc=" + versionInfo);
            CustomizeOMPTOCDAO.insertBatch(doc2);
            return true;
        } catch (Exception e) {
            e.printStackTrace();
            return false;
        }
    }

    public static boolean writeFiletoWTDocByFlexible(File file, WTDocument doc, String head) {
        try {
            ContentHolder contentholder = ContentHelper.service.getContents(doc);
            List<Object> contentListForTarget = ContentHelper.getContentListAll(contentholder);
            int i = 0;
            while (true) {
                if (i >= contentListForTarget.size()) {
                    break;
                }
                ContentItem contentItem = (ContentItem) contentListForTarget.get(i);
                if (!"PRIMARY".equals(contentItem.getRole().toString())) {
                    i++;
                } else {
                    ContentServerHelper.service.deleteContent(contentholder, contentItem);
                    break;
                }
            }
            ApplicationData appData = ApplicationData.newApplicationData(doc);
            appData.setRole(ContentRoleType.PRIMARY);
            appData.setFileName(String.valueOf(head) + "--" + doc.getName() + "--" + file.getName());
            String fileName = String.valueOf(head) + "--" + doc.getName() + "--" + file.getName();
            StandardContentService.setFormat(fileName, appData);
            InputStream is = new FileInputStream(file);
            ContentServerHelper.service.updateContent(doc, appData, is);
            WTDocument doc2 = PersistenceHelper.manager.refresh(doc);
            String version = doc2.getVersionIdentifier().getValue();
            String iter = doc2.getIterationIdentifier().getValue();
            String versionInfo = String.valueOf(version.toUpperCase()) + iter.toUpperCase();
            System.out.println("**********************writeFiletoWTDoc=" + versionInfo);
            CustomizeOMPTOCDAO.insertBatch(doc2);
            return true;
        } catch (Exception e) {
            e.printStackTrace();
            return false;
        }
    }

    public static List<PublishDocViewDataTable> getAllPublishDoc(String oid) {
        return null;
    }
}
